Merge "Fix quagga user and dirs"
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
39       else
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
41       fi
42     else
43       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
44     fi
45     SDN_IMAGE=opendaylight
46   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
47     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
48     SDN_IMAGE=opendaylight
49   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
50     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
51     exit 1
52     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
53     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
54     #else
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
56     #fi
57     #SDN_IMAGE=onos
58   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
59     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
60     exit 1
61   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
62     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
63     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
64       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
65     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   else
70     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
71     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
72     exit 1
73   fi
74
75   # Enable Tacker
76   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
77     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
78   fi
79
80   # Enable Congress
81   if [ "${deploy_options_array['congress']}" == 'True' ]; then
82     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
83   fi
84
85   # Enable Real Time Kernel (kvm4nfv)
86   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
87     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
88   fi
89
90   # Make sure the correct overcloud image is available
91   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
92       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
93       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
94       exit 1
95   fi
96
97   echo "Copying overcloud image to Undercloud"
98   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
99   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
100
101   # disable neutron openvswitch agent from starting
102   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
103       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
104       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
105       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
106                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
107                                                -a overcloud-full.qcow2
108 EOI
109   fi
110
111   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
112       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
113       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
115                                                --run-command "sudo usermod -a -G quaggavt quagga" \
116                                                --run-command "sudo mkdir -p /var/run/quagga/" \
117                                                --run-command "sudo chown quagga:quagga -R /var/run/quagga/" \
118                                                --run-command "systemctl enable zrpcd" \
119                                                -a overcloud-full.qcow2
120 EOI
121   fi
122
123   # Install ovs-dpdk inside the overcloud image if it is enabled.
124   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
125     # install dpdk packages before ovs
126     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
127
128     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
129       cat << EOF > vfio_pci.modules
130 #!/bin/bash
131 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
132 EOF
133
134       cat << EOF > uio_pci_generic.modules
135 #!/bin/bash
136 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
137 EOF
138
139       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
140                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
141                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
142                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
143                                                -a overcloud-full.qcow2
144
145       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
146         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
147       fi
148
149 EOI
150
151   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
152     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
153     exit 1
154   fi
155
156   if [ "$debug" == 'TRUE' ]; then
157     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
158   fi
159
160   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
161   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
162     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
163          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
164                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
165                                                   -a overcloud-full.qcow2
166 EOI
167   fi
168
169   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
170   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
171     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
172       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
173                                                -a overcloud-full.qcow2
174 EOI
175
176     # Disable clustering for ODL FDIO HA scenarios
177     if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
178       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
179       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /etc/puppet/modules/tripleo/ && patch -p1 < disable_odl_clustering.patch" \
180                                                -a overcloud-full.qcow2
181 EOI
182     fi
183
184     # Configure routing node for odl_l3-fdio
185     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
186       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
187         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
188 EOI
189     fi
190   fi
191
192   if [ -n "${deploy_options_array['performance']}" ]; then
193     ovs_dpdk_perf_flag="False"
194     for option in "${performance_options[@]}" ; do
195       arr=($option)
196       # use compute's kernel settings for all nodes for now.
197       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
198         kernel_args+=" ${arr[2]}=${arr[3]}"
199       fi
200       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
201          eval "${arr[2]}=${arr[3]}"
202          ovs_dpdk_perf_flag="True"
203       fi
204     done
205
206     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
207       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
208       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
209       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
210 EOI
211
212     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
213       for ovs_option in ${!ovs_option_heat_arr[@]}; do
214         if [ -n "${!ovs_option}" ]; then
215           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
216             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
217 EOI
218         fi
219       done
220     fi
221   fi
222
223   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
224     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
225       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
226         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
227           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
228 EOI
229       else
230         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
231         exit 1
232       fi
233     fi
234   fi
235
236   # Set ODL version accordingly
237   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
238     case "${deploy_options_array['odl_version']}" in
239       beryllium) odl_version=''
240               ;;
241       boron)  odl_version='boron'
242               ;;
243       carbon) odl_version='master'
244               ;;
245       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
246          exit 1
247          ;;
248     esac
249
250     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
251       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
252                                                --run-command "yum -y install /root/${odl_version}/*" \
253                                                -a overcloud-full.qcow2
254 EOI
255   fi
256
257   # Override ODL if FDIO and ODL L2
258   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['sdn_l3']}" == "False" ]]; then
259     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
260          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
261                                                   --run-command "yum -y install /root/fdio_l2/opendaylight*.rpm" \
262                                                   -a overcloud-full.qcow2
263 EOI
264   fi
265
266   # check if ceph should be enabled
267   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
268     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
269   fi
270
271   # get number of nodes available in inventory
272   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
273   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
274
275   # check if HA is enabled
276   if [[ "$ha_enabled" == "True" ]]; then
277     if [ "$num_control_nodes" -lt 3 ]; then
278       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
279       exit 1
280     else
281      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
282      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
283      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
284     fi
285   else
286     if [ "$num_control_nodes" -lt 1 ]; then
287       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
288       exit 1
289     fi
290   fi
291
292   if [ "$num_compute_nodes" -le 0 ]; then
293     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
294     exit 1
295   else
296     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
297     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
298   fi
299
300   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
301
302   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
303   if [[ "$virtual" == "TRUE" ]]; then
304      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
305   fi
306
307   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
308
309   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
310 # Create a key for use by nova for live migration
311 echo "Creating nova SSH key for nova resize support"
312 ssh-keygen -f nova_id_rsa -b 1024 -P ""
313 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
314 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
315 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
316 mv -f opnfv-environment-new.yaml ${ENV_FILE}
317
318 source stackrc
319 set -o errexit
320 # Workaround for APEX-207 where sometimes swift proxy is down
321 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
322   sudo systemctl restart openstack-swift-proxy
323 fi
324 echo "Uploading overcloud glance images"
325 openstack overcloud image upload
326
327 echo "Configuring undercloud and discovering nodes"
328 openstack baremetal import --json instackenv.json
329
330 if [[ -z "$virtual" ]]; then
331   openstack baremetal introspection bulk start
332   if [[ -n "$root_disk_list" ]]; then
333     openstack baremetal configure boot --root-device=${root_disk_list}
334   else
335     openstack baremetal configure boot
336   fi
337 else
338   openstack baremetal configure boot
339 fi
340
341 echo "Configuring flavors"
342 for flavor in baremetal control compute; do
343   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
344   if openstack flavor list | grep \${flavor}; then
345     openstack flavor delete \${flavor}
346   fi
347   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
348   if ! openstack flavor list | grep \${flavor}; then
349     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
350   fi
351 done
352 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
353 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
354 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
355 echo "Configuring nameserver on ctlplane network"
356 dns_server_ext=''
357 for dns_server in ${dns_servers}; do
358   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
359 done
360 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
361 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
362 echo "Executing overcloud deployment, this should run for an extended period without output."
363 sleep 60 #wait for Hypervisor stats to check-in to nova
364 # save deploy command so it can be used for debugging
365 cat > deploy_command << EOF
366 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
367 EOF
368 EOI
369
370   if [ "$interactive" == "TRUE" ]; then
371     if ! prompt_user "Overcloud Deployment"; then
372       echo -e "${blue}INFO: User requests exit${reset}"
373       exit 0
374     fi
375   fi
376
377   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
378 source stackrc
379 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
380 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
381   $(typeset -f debug_stack)
382   debug_stack
383   exit 1
384 fi
385 EOI
386
387   # Configure DPDK and restart ovs agent after bringing up br-phy
388   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
389     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
390 source stackrc
391 set -o errexit
392 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
393 echo "Checking DPDK status and bringing up br-phy on \$node"
394 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
395 set -o errexit
396 sudo dpdk-devbind -s
397 sudo ifup br-phy
398 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
399   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
400   sudo systemctl restart neutron-openvswitch-agent
401 fi
402 EOF
403 done
404 EOI
405   fi
406
407   if [ "$debug" == 'TRUE' ]; then
408       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
409 source overcloudrc
410 echo "Keystone Endpoint List:"
411 openstack endpoint list
412 echo "Keystone Service List"
413 openstack service list
414 EOI
415   fi
416 }